﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.TradeRules
{
    [StorableClass]
    [Item("Average", "Symbol that represents the average (arithmetic mean) function.")]
    public class AverageTrade : Symbol
    {
        private const int minimumArity = 1;
        private const int maximumArity = 1;

        public override int MinimumArity
        {
            get { return minimumArity; }
        }
        public override int MaximumArity
        {
            get { return maximumArity; }
        }

        [StorableConstructor]
        private AverageTrade(bool deserializing) : base(deserializing) { }
        private AverageTrade(AverageTrade original, Cloner cloner) : base(original, cloner) { }
        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new AverageTrade(this, cloner);
        }
        public AverageTrade() : base("AverageTrade", "Symbol that represents the average (arithmetic mean) function.") { }
    }
}
